///////////////////////////////////////////////////////////////////////
///////////////////////Mod by @signol on Discord///////////////////////
///////////////////////////////////////////////////////////////////////



//////////////////////Functions//////////////////////

local function fuseTrans(tics)
	if tics > TICRATE then return 0 end
	if tics > TICRATE/10*9 then return FF_TRANS10 end
	if tics > TICRATE/10*8 then return FF_TRANS20 end
	if tics > TICRATE/10*7 then return FF_TRANS30 end
	if tics > TICRATE/10*6 then return FF_TRANS40 end -- LOL
	if tics > TICRATE/10*5 then return FF_TRANS50 end
	if tics > TICRATE/10*4 then return FF_TRANS60 end
	if tics > TICRATE/10*3 then return FF_TRANS70 end
	if tics > TICRATE/10*2 then return FF_TRANS80 end
	return FF_TRANS90
end



//////////////////////Freeslots//////////////////////

freeslot("sfx_xdlmao", "sfx_bully1", "sfx_bully2", "sfx_bully3", "sfx_bully4", "sfx_bully5", "sfx_bully6", "sfx_bully7", "sfx_bully8", "sfx_bully9")

sfxinfo[sfx_xdlmao].flags = SF_X4AWAYSOUND
sfxinfo[sfx_xdlmao].caption = "Kablooey!"

sfxinfo[sfx_bully1].caption = "Ciao!"
sfxinfo[sfx_bully2].caption = "Muta Laugh"
sfxinfo[sfx_bully3].caption = "ah! so scary!"
sfxinfo[sfx_bully4].caption = "Womp..."
sfxinfo[sfx_bully5].caption = "Confusion"
sfxinfo[sfx_bully6].caption = "WA-"
sfxinfo[sfx_bully7].caption = "The Curse..."
sfxinfo[sfx_bully8].caption = ":("
sfxinfo[sfx_bully9].caption = "You lose!!!!!"



freeslot("SPR_REKT", "SPR_REKD", "SPR_EXLP")
freeslot("S_KEKW", "S_INVERSEBOOM", "S_STOCKPLOSION", "S_FREEZE")

states[S_KEKW] = {
	sprite = SPR_REKT,
	frame = FF_FULLBRIGHT|A,
	tics = TICRATE,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_INVERSEBOOM] = {
	sprite = SPR_REKD,
	frame = FF_FULLBRIGHT|FF_SUBTRACT|FF_TRANS50|A,
	tics = TICRATE,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_STOCKPLOSION] = {
	sprite = SPR_EXLP,
	frame = FF_FULLBRIGHT|FF_ANIMATE|A,
	tics = 15,
	action = nil,
	var1 = 8,
	var2 = 2,
	nextstate = S_NULL
}

states[S_FREEZE] = {
	sprite = SPR_PLAY,
	frame = SPR2_STND,
	tics = 25,
	action = nil,
	var1 = nil,
	var2 = nil,
	nextstate = S_NULL
}

freeslot("MT_KEKW", "MT_INVERSEBOOM", "MT_STOCKPLOSION", "MT_FREEZE")

mobjinfo[MT_KEKW] = {
	doomednum = -1,
	spawnstate = S_KEKW,
	dispoffset = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}

mobjinfo[MT_INVERSEBOOM] = {
	doomednum = -1,
	spawnstate = S_INVERSEBOOM,
	dispoffset = -1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}

mobjinfo[MT_STOCKPLOSION] = {
	doomednum = -1,
	spawnstate = S_STOCKPLOSION,
	dispoffset = 4,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}

mobjinfo[MT_FREEZE] = {
	doomednum = -1,
	spawnstate = S_FREEZE,
	dispoffset = 0,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY
}



///////////////////////Console///////////////////////

local cmdtoggle = true
local cmdcountdown = 0

addHook("NetVars", function(net)
	cmdtoggle = net($)
	cmdcountdown = net($)
end)

COM_AddCommand('stopmove', function(p)

	if cmdcountdown then
		CONS_Printf(p, "\x82Please wait.")
		return
	end
	
	if cmdtoggle then
	
		S_StartSound(nil, sfx_s3kb7)
		cmdtoggle = false
		
		if netgame then
			chatprint("\x82WASD is now enabled.")
		else
			CONS_Printf(p, "\x82WASD is now enabled.")
		end
	else
	
		S_StartSound(nil, sfx_s3k36)
		cmdcountdown = 2*TICRATE
		
		if netgame then
			chatprint("\x82WASD is disabling in 2 seconds!")
		else
			CONS_Printf(p, "\x82WASD is disabling in 2 seconds!")
		end
	end
end, COM_ADMIN)

addHook("ThinkFrame", function()
	if cmdcountdown then
	
		if cmdcountdown == 1 then
			
			S_StartSound(nil, sfx_s3k73)
			cmdtoggle = true
			
			if netgame then
				chatprint("\x82WASD is now disabled. Good luck!")
			else
				CONS_Printf(consoleplayer, "\x82WASD is now disabled. Good luck!")
			end
		end
	
		cmdcountdown = $-1
	end
end)



////////////////////////Main////////////////////////

addHook("MobjThinker", function(mobj)
	mobj.frame = A|FF_FULLBRIGHT|fuseTrans(mobj.fuse)
	mobj.z = mobj.z + FU/2
end, MT_KEKW)



addHook("PreThinkFrame", function()
	for p in players.iterate do
		if not p.valid then continue end
		if p.powers[pw_carry] == CR_NIGHTSMODE then continue end
		
		if p.rektTimer == nil then
			p.rektTimer = 0
		end
		
		
		if cmdtoggle then
		
			if p.mo and p.mo.valid and not (p.playerstate == PST_DEAD or p.rektTimer) then
				
				if p.cmd.forwardmove ~= 0 or p.cmd.sidemove ~= 0 then
					
					P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height + 6*FU, MT_KEKW)
					
					local effectSphere = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_INVERSEBOOM)
						effectSphere.scale = 4*FU
						effectSphere.scalespeed = FU/5
						effectSphere.destscale = 0
					
					local freeze = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_FREEZE)
						freeze.angle = p.drawangle
						freeze.color = p.mo.color
						freeze.skin = p.mo.skin
						freeze.sprite2 = p.mo.sprite2
						freeze.frame = p.mo.frame
					
					S_StartSound(p.mo, sfx_kc31)
					S_StartSound(p.mo, P_RandomRange(sfx_bully1, sfx_bully9))
					
					p.rektTimer = 7 + 26
					
				end
			end
		end
		
	end
end)

addHook("PlayerThink", function(p)
	if p.valid and p.mo and p.mo.valid then
		if p.powers[pw_carry] == CR_NIGHTSMODE then return end
	
		if p.rektTimer then
		
			if p.rektTimer > 8 then
			
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0
				p.mo.pmomz = 0
				
				p.mo.flags2 = $|MF2_DONTDRAW
			
			elseif p.rektTimer == 8 then
			
				p.mo.flags2 = $ & ~MF2_DONTDRAW
				
				S_StartSound(p.mo, sfx_xdlmao)
				
				P_KillMobj(p.mo, nil, nil, DMG_INSTAKILL)
				
				local explosion = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_STOCKPLOSION)
				explosion.scale = 4*FU

				P_FlashPal(p, PAL_WHITE, 7)
				
				if p == consoleplayer then
					P_StartQuake(FU*16, TICRATE/2)
				end
				
			elseif p.rektTimer == 1 then
			
				P_FlashPal(p, PAL_NUKE, TICRATE/4)
				
			end
			
			p.rektTimer = $-1
			
		end
	
	end
end)










